use vm_core::vm::Vm;
use vm_builtin::task_pool::VmTaskPool;

// 添加管理端执行pid
pub fn mgr_pid_handle(workers: &[Vm<VmTaskPool>]) {
    for vm in workers {
        let vm_copy = vm.clone();
        let vm = vm.clone();
        let cid = vm.alloc_context_id();
        debug!(
            "!!!!!!!!!!!!!!mgr_pid_handle vid: {:?}, cid:{:?}",
            vm.get_vid(),
            cid
        );
        vm.spawn_task(async move {
            let context = vm_copy.new_context(None, cid, None).await.unwrap();
            if let Err(e) = vm_copy
                .execute(context, "start_mgr_pid.js", r#"
                var mgrPid = self.Module.require("pi_pt/mgr/mgr_pid.js");
                mgrPid._$set_receive();"#)
                .await
            {
                panic!(e);
            }
        });
    }
}
